#!/bin/ksh

awk '

$1 ~ /^_1_$/ {
    printf("INSTR:ignore = display()\n");
    print "EXPR:";
    fflush();
    next;
}

$1 ~ /^$/ {
    print "EXPR:";
    fflush();
    next;
}

$1 ~ /^[a-z]\+[a-z]$/ {
    printf("INSTR:ignore = sum()\n");
    printf("EXPR:_%s_\n", 1);
    fflush();
    next;
}

$1 ~ /^[a-z]\*[a-z]$/ {
    printf("INSTR:ignore = product()\n");
    printf("EXPR:_%s_\n", 1);
    fflush();
    next;
}

$1 ~ /^[a-z]-[a-z]$/ {
    printf("INSTR:subtract()\n");
    printf("EXPR:%s\n", 1);
    fflush();
    next;
}

$1 ~ /^[a-z]\/*[a-z]$/ {
    printf("INSTR:divide()\n");
    printf("EXPR:%s\n", 1);
    fflush();
    next;
}

$1 ~ /^[a-z]\^*[a-z]$/ {
    printf("INSTR:conjugate()\n");
    printf("EXPR:%s\n", 1);
    fflush();
    next;
}

{
    expr = $1;
    len = length(expr);
    printf("INSTR:%s\n", substr(expr,1,1));
    printf("EXPR:%s\n",  substr(expr,2,len-1));
    fflush();
    next;
}

' |&

{

echo '

define prompt() {
print "> "
}

define display() {
print "[1,2,3,4]\n"
}

define sum() {
print "sum: "
}

define product() {
print "product: "
}

define subtract() {
print "subtract: "
}

define divide() {
print "divide: "
}

define conjugate() {
print "conjugate: "
}

ignore = prompt()

'

while read
do
    [[ $REPLY == quit ]] && break

    expr=$REPLY

    while true
    do
	print -p ${expr}

	while read -pr result
	do
	    [[ $result == @(EXPR:*)  ]] && break
	    [[ $result == @(INSTR:*) ]] && print -r "${result#INSTR:}"
	done

	expr=${result#EXPR:}

	[[ -z $expr ]] && break
    done

    print "ignore = prompt()"
done

} |

bc -q
