#!/bin/bash

a[0]=0
b[0]=1
e[0]=1
f[0]=1

for ((i=1; i<=4; ++i))
do
    a[i]=$((   a[i-1] +  4*e[i-1] ))
    b[i]=$(( 3*b[i-1] + 10*f[i-1] ))
    e[i]=$((  -e[i-1]             ))
    f[i]=$((  -b[i-1] -  3*f[i-1] ))
done

{
    cat poly.mod.bc

    for ((i=0; i<=4; ++i))
    do

    cat <<EOF
    a=${a[i]}
    b=${b[i]}
    e=${e[i]}
    f=${f[i]}

    x4coeff = coeff_x4(a,b,e,f)
    x3coeff = coeff_x3(a,b,e,f)
    x2coeff = coeff_x2(a,b,e,f)
    x1coeff = coeff_x1(a,b,e,f)
    x0coeff = coeff_x0(a,b,e,f)

    print " a = ", a
    print " b = ", b
    print " e = ", e
    print " f = ", f
    print " ;  "

    print x4coeff, "*x^4 + "
    print x3coeff, "*x^3 + "
    print x2coeff, "*x^2 + "
    print x1coeff, "*x^1 + "
    print x0coeff, "*x^0\n"
EOF

    done

} |

bc -q |

awk -F\; '{ printf("%-32s :: %s\n", $1, $2) }'